/**
 * @param {Object} fromPage
 * 跳转获取jsapi 支付的 code
 */
export function laikeToUrl(fromPage) {
	var me = fromPage;
	var locationUrl = window.location.href
	var data = {
		type: 'jsapi_wechat',
		access_id: me.access_id,
		app: 'get_config',
		module: "app",
		action: "commcenter",
		url: locationUrl
	}
	uni.request({
		data,
		url: uni.getStorageSync("url"),
		header: {
			'content-type': 'application/x-www-form-urlencoded'
		},
		method: 'POST',
		success: (res) => {
			if (res.data.code == 200) {
				var myappid = res.data.data.config.appid
				me.myappid = myappid
				var myUrl = res.data.data.url
				var url = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + myappid +
					"&redirect_uri=" + myUrl +
					"&response_type=code&scope=snsapi_base&state=STATE#wechat_redirect";
				window.location.href = url
			} else {
				uni.showToast({
					title: res.data.message,
					duration: 1500,
					icon: 'none'
				})
			}
		},
		error: function(err) {
			console.log(err)
		}
	})
}

/**
 * @param {Object} fromPage
 * 使用余额
 */
export function laikeUseyue(fromPage) {
	var me = fromPage;
	if (me.pay_name == 'jp') {
		let needpay = parseFloat(me.jp_zong - me.value).toFixed(2)
		if (needpay > 0) {
			me.needpay = needpay
		} else {
			me.needpay = 0
		}
	} else if (me.bargain) {
		let needpay = parseFloat(me.products_total + me.freight - me.value).toFixed(2)
		if (needpay > 0) {
			me.needpay = needpay
		} else {
			me.needpay = 0
		}
	} else {
		console.log(me.coupon_name);
		let needpay = parseFloat(me.products_total * me.discount + me.freight - me.coupon_name - me.reduce_money - me.value).toFixed(
			2)
		if (needpay > 0) {
			me.needpay = needpay
		} else {
			me.needpay = 0
		}
	}
}

/**
 * 支付
 * @param {Object} fromPage
 */
export function laikePayThree(fromPage) {
	var me = fromPage;
	if (me.useWallte) {
		if (me.wxPayStatue) {
			me.pay_wx()
		} else {
			uni.showToast({
				title: "请选择支付方式！",
				duration: 1000,
				icon: 'none'
			})
			me.firstFlag = true;
		}
	} else {
		if (me.wxPayStatue || me.aliPayStatue) {
			if (me.pay_name == "jp") {
				var data = {
					module: 'app',
					action: 'order',
					app: 'payment',
					access_id: me.access_id,
					address_id: me.address_id,
					type: "JP",
					auction_id: me.bind_id,
					coupon_id: me.coupon_id
				}
				if (me.cpId) {
					data.product = me.cpId
					cart_id: ''
				}
			} else if (me.bargain) {
				var data = {
					module: 'app',
					action: 'order',
					app: 'payment',
					type: "KJ",
					cart_id: me.cart_id,
					access_id: me.access_id,
					address_id: me.address_id,
					bargain_id: me.bargain_id,
					bargain_order_no: me.order_no
				}
				if (me.cpId) {
					data.product = me.cpId
					cart_id: ''
				}
			} else {
				var data = {
					module: 'app',
					action: 'order',
					app: 'payment',
					cart_id: me.cart_id,
					access_id: me.access_id,
					address_id: me.address_id,
					coupon_id: me.coupon_id,
				}
				if (me.cpId) {
					data.product = me.cpId
					cart_id: ''
				}
			}
			if (me.wxPayStatue) {
				// #ifdef MP-WEIXIN
				data.pay_type = 'mini_wechat'
				data.store_type = 1
				// #endif
				//#ifdef APP-PLUS
				data.pay_type = 'app_wechat'
				data.store_type = 2
				// #endif
				//#ifdef H5
				data.pay_type = 'jsapi_wechat'
				data.store_type = 2
				// #endif
			} else if (me.aliPayStatue) {
				data.pay_type = 'aliPay'
			}

			uni.request({ //创建订单
				data,
				url: uni.getStorageSync("url"),
				header: {
					'content-type': 'application/x-www-form-urlencoded'
				},
				method: 'POST',
				success: (res1) => { //支付
					uni.hideLoading()
					let {
						data: {
							status,
							data
						}
					} = res1
					me.order_list = JSON.stringify(data)
					if (status == 0) {
						uni.showToast({
							title: res1.data.err,
							duration: 1500,
							icon: 'none'
						});
						return;
					}

					if (status == 1) {
						me.sNo = res1.data.data.sNo
						me.price1 = res1.data.data.total
						me.order_id = res1.data.data.order_id
						if (me.wxPayStatue) {
							me.pay_wx('wx')
						} else if (me.aliPayStatue) {
							me.pay_wx('ali')
						}
					}
				},
				error: function(err) {
					uni.hideLoading()
					me.firstFlag = true
					uni.showToast({
						title: "创建订单失败,请稍后再试!",
						duration: 1500,
						icon: 'none'
					})
					setTimeout(function() {
						uni.navigateBack({
							delta: 1
						})
					}, 1500)
				}
			})
		} else {
			uni.showToast({
				title: "请选择支付方式！",
				duration: 1000,
				icon: 'none'
			})
			me.firstFlag = true;
		}
	}
}


/**
 * 选择支付方式
 * @param {Object} fromPage
 * @param {Object} way
 */
export function laikeChooseWay(fromPage, way) {
	var me = fromPage;
	//微信支付
	if (way == 'wxPay') {
		if (!me.wxPayStatue) {
			me.wxPayStatue = true
			me.aliPayStatue = false
		} else {
			me.wxPayStatue = false
		}
	}
	//支付宝支付
	else if (way == 'aliPay') {
		if (!me.aliPayStatue) {
			me.wxPayStatue = false
			me.aliPayStatue = true
		} else {
			me.aliPayStatue = false
		}
	}
}

/**
 * 订单详情页面余额支付开关按钮
 * 
 * @param {Object} fromPage
 */
export function laikeSwitchChange(e, fromPage) {
	var me = fromPage;
	if (Number(me.user_money) <= 0) {
		return
	}
	me.useWallte = e.detail.value
	if (!e.detail.value) {
		me.value2 = me.value
		me.value = ''
		me.needpay = ''
	} else {
		if (me.total >= Number(me.user_money)) {
			me.value = me.user_money
			console.log("me.value=================1");
			console.log(me.value);
			me.needpay = parseFloat(me.total - Number(me.user_money)).toFixed(2)
		} else if (me.bargain) {
			me.value = me.products_total + me.freight
			console.log("me.value=================2");
			console.log(me.value);
			me.needpay = 0
		} else {
			me.value = parseFloat(me.products_total * me.discount + me.freight - me.coupon_name - me.reduce_money).toFixed(2)
			console.log("me.value=================3");
			console.log(me.value);
			let heji = me.products_total * me.discount + me.freight - me.coupon_name - me.reduce_money
			me.total = heji
			me.needpay = 0
			if (me.value === '') {
				me.value = me.value2
			}
			if (heji - me.value > 0) {
				me.needpay = heji - me.value
			}
		}
	}
}


/**
 * 
 * @param {Object} fromPage
 * @param {Object} newValue
 * @param {Object} oldValue
 */
export function laikeChangeValue(fromPage, newValue, oldValue) {
	let me = fromPage;
	me.$nextTick(function() {
		me.price1 = me.products_total * me.discount + me.freight - me.coupon_name - me.reduce_money
		me.price2 = me.price1.toFixed(2)
		console.log('============price2');
		console.log(me.price2);
		if (me.price2 < 0) {
			me.price2 = 0.01
		}
		let should_pay = me.products_total + me.freight - me.coupon_name - me.reduce_money
		if (Number(me.value) >= should_pay) { //输入金额大于商品金额
			if (should_pay <= me.user_money) {
				
					me.value = should_pay.toFixed(2)
					console.log(should_pay);
					console.log("me.value=================4");
					console.log(me.value);
			
			} else {
				me.value = me.user_money
				console.log("me.value=================6");
				console.log(me.value);
			}
			if (Number(me.value).toFixed(2) > should_pay.toFixed(2) && should_pay.toFixed(2) > 0) {
				console.log('===========是否超过最大金额');
				console.log(Number(me.value));
				console.log(should_pay);
				uni.showToast({
					title: '已超过最大金额',
					icon: 'none',
					duration: 1500
				})
			}
			// 补充：当使用余额大于合计金额时，将还需支付置为0 Number(0).toFixed(2)
		} else if (Number(me.value) < should_pay) { //输入金额小于商品金额
			if (Number(me.value) > me.user_money) {
				me.value = me.user_money
				console.log("me.value=================7");
				console.log(me.value);
				uni.showToast({
					title: '已超过最大金额',
					icon: 'none',
					duration: 1500
				})
			}
		}
		if (me.products_total + me.freight - me.coupon_name - Number(me.reduce_money) - Number(me.value) <
			0.0099999999) {
			// me.value=Number(me.value).toFixed(2)
		}
		if (Math.abs(newValue - oldValue) == 0) {
			var x = String(newValue).indexOf('.') + 1;
			var y = String(newValue).length - x;
			if (y > 2 && x != 0) {
				me.value = Number(newValue).toFixed(2)
				console.log("me.value=================8");
				console.log(me.value);
			}
		} else if (Math.abs(newValue - oldValue) < 0.009999999999) {
			me.value = Number(me.value).toFixed(2)
			console.log("me.value=================9");
			console.log(me.value);
		}
	})
}


/**
 * 获取订单基本信息
 * @param {Object} fromPage
 */
export function laikeGetOrderInfo(fromPage,type) {
	let me = fromPage;
	let data = {
		access_id: me.access_id,
		order_list: me.order_list,
		title: '',
		module: 'app',
		action: 'pay',
		type: 'app_wechat',
		type_: 'KJ',
		total: me.price1,
		bargain_order_no: me.order_no
	}
	if (me.pay_name == 'jp') {
		data.title = me.jp_name
	} else {
		data.title = me.pro[0].list[0].product_title
	}
	// #ifdef H5
	if (type == 'wx') {
		data.type = 'jsapi_wechat'
		data.code = me.code
	} else if (type == 'ali') {
		data.type = 'alipay_mobile'
	}
	// #endif

	// #ifndef H5
	if (type == 'wx') {
		data.type = 'app_wechat'
	} else if (type == 'ali') {
		data.type = 'alipay'
	}
	// #endif

	return new Promise((res) => {
		uni.request({
			url: uni.getStorageSync("url"),
			data,
			success: (result) => {
				if (result.statusCode == 200) {
					res(result);
					if (type == 'wx') {
						//微信支付
					} else if (type == 'ali') {
						//支付宝支付
						me.h5_content = result.data;
					}
				} else if (result.data.code != undefined && result.data.code != 200) {
					uni.showToast({
						title: result.data.message,
						duration: 1500,
						icon: 'none'
					});
				}
			},
			fail: (e) => {
				res(e);
			}
		})
	})
}


/**
 * 微信小程序支付
 * @param {Object} fromPage
 */
export function laikeWeixinPay(fromPage) {
	let me = fromPage;
	me.loading = true;
	uni.login({
		provider: 'weixin',
		success: (e) => {
			var data;
			if (me.pay_name == "jp") {
				data = {
					code: e.code,
					order_list: me.order_list,
					title: me.jp_name,
					type: 'mini_wechat',
					access_id: me.access_id,
					total: me.jp_zong,
					module: 'app',
					action: 'pay',
				}
			} else if (me.bargain) {
				data = {
					code: e.code,
					order_list: me.order_list,
					title: me.pro[0].list[0].product_title,
					type: 'mini_wechat',
					type_: 'KJ',
					access_id: me.access_id,
					total: me.price1,
					module: 'app',
					action: 'pay',
				}
			} else {
				data = {
					code: e.code,
					order_list: me.order_list,
					title: me.pro[0].list[0].product_title,
					type: 'mini_wechat',
					access_id: me.access_id,
					total: me.price1,
					module: 'app',
					action: 'pay',
				}
			}
			uni.request({
				url: uni.getStorageSync("url"),
				data,
				success: (res) => {
					uni.hideLoading();
					if (res.statusCode !== 200) {
						uni.showModal({
							title: '提示',
							content: '支付失败,查看订单详情',
							success: function(res) {
								if (res.confirm) {
									uni.redirectTo({
										url: '../order/myOrder'
									})
								} else if (res.cancel) {
									uni.switchTab({
										url: '../tabBar/home'
									})
								}
							}
						});
						return;
					} else if (res.statusCode == 200) {
						let paymentData = res.data;
						uni.requestPayment({
							provider: 'wxpay',
							timeStamp: paymentData.timeStamp,
							nonceStr: paymentData.nonceStr,
							package: paymentData.package,
							signType: 'MD5',
							paySign: paymentData.paySign,
							success: (res) => {
								uni.showToast({
									title: '支付成功！',
									duration: 1000,
									icon: 'none'
								})
								setTimeout(function() {
									me.$store.state.payRes = me.order_list
									uni.redirectTo({
										url: "payResult"
									})
									me.pay_display = false
								}, 1000)
							},
							fail: (res) => {
								uni.showModal({
									title: '提示',
									content: '支付失败,可在订单列表中查看',
									success: function(res) {
										if (res.confirm) {
											uni.redirectTo({
												url: '../order/myOrder'
											})
										} else if (res.cancel) {
											uni.switchTab({
												url: '../tabBar/home'
											})
										}
									}
								})
							},
							complete: () => {
								me.loading = false;
							}
						})
					} else {
						uni.showModal({
							title: '提示',
							content: '支付失败,可在订单列表中查看',
							success: function(res) {
								me.firstFlag = true
								if (res.confirm) {
									uni.redirectTo({
										url: '../order/myOrder'
									})
								} else if (res.cancel) {
									uni.switchTab({
										url: '../tabBar/home'
									})
								}
							}
						})
					}
				},
				fail: (e) => {
					me.loading = false;
					uni.hideLoading();
					uni.showModal({
						title: '提示',
						content: '支付失败,查看订单详情',
						success: function(res) {
							me.firstFlag = true
							if (res.confirm) {
								uni.redirectTo({
									url: '../order/myOrder'
								})
							} else if (res.cancel) {
								uni.switchTab({
									url: '../tabBar/home'
								})
							}
						}
					})
				}
			})
		},
		fail: (e) => {
			me.loading = false;
			uni.hideLoading();
			uni.showModal({
				title: '提示',
				content: '支付失败,查看订单详情',
				success: function(res) {
					me.firstFlag = true
					if (res.confirm) {
						uni.redirectTo({
							url: '../order/myOrder'
						})
					} else if (res.cancel) {
						uni.switchTab({
							url: '../tabBar/home'
						})
					}
				}
			})
		}
	})
}


/**
 * 支付失败
 * @param {Object} fromPage
 */
export function laikePayFail(fromPage) {
	let me = fromPage;
	uni.showModal({
		title: '提示',
		content: '支付失败,查看订单详情',
		success: function(res) {
			me.firstFlag = true
			// #ifdef H5
			var url = uni.getStorageSync("h5_url") + "pages/order/myOrder?status=1";
			if (res.cancel) {
				url = uni.getStorageSync("h5_url") + "pages/tabBar/home";
			}
			location.href = url
			// if (res.confirm) {
			// 	uni.redirectTo({
			// 		url: '../order/myOrder'
			// 	})
			// } else if (res.cancel) {
			// 	uni.switchTab({
			// 		url: '../tabBar/home'
			// 	})
			// }
			// #endif
			// #ifndef H5
			me.$store.state.payRes = me.order_list
			if (res.confirm) {
				uni.redirectTo({
					url: '../order/myOrder'
				})
			} else if (res.cancel) {
				uni.switchTab({
					url: '../tabBar/home'
				})
			}
			// #endif
		}
	})
}


/**
 * 支付
 * @param {Object} fromPage		
 * @param {Object} payType 		支付类型
 */
export async function laikePay(fromPage, payType) {
	let me = fromPage;
	let type = payType;

	if (!type) {
		return;
	}
	let orderInfo = await me.getOrderInfo(type)
	var providerStr = "";
	if (type == 'wx') {
		providerStr = 'wxpay'
	} else if (type == 'ali') {
		providerStr = 'alipay'
	}
	if (orderInfo.statusCode !== 200) {
		me._payFail();
	}
	var str = JSON.stringify(orderInfo.data)
	uni.hideLoading()
	// #ifdef H5
	if (type == 'ali') {
		var url = uni.getStorageSync("endurl") + 'order/' + me.sNo + '_alipay.html'
		window.location.href = url
	} else if (type == 'wx') {
		var paymentData = orderInfo.data;

		function onBridgeReady() {
			WeixinJSBridge.invoke(
				'getBrandWCPayRequest', {
					"appId": paymentData.appid, //公众号名称，由商户传入     
					"timeStamp": paymentData.timeStamp, //时间戳，自1970年以来的秒数     
					"nonceStr": paymentData.nonceStr, //随机串     
					"package": paymentData.package,
					"signType": paymentData.signType, //微信签名方式：     
					"paySign": paymentData.paySign //微信签名 
				},
				function(res) {
					me.firstFlag = true;
					me.code == '';
					var url = window.location.href;
					var preUrl = url.split("#")[0];
					var succUrl = preUrl.concat("#/pages/pay/payResult");
					//支付成功
					if (res.err_msg == "get_brand_wcpay_request:ok") {
						me.$store.state.payRes = me.order_list;
						var price = me.price1;
						// #ifdef H5
						var price = Number(me.price1) + Number(me.value);
						// #endif
						var sno = me.sNo;
						window.location.href = uni.getStorageSync("h5_url") + "pages/pay/payResult?payment_money=" + price + "&sNo=" +
							sno;
					} else {
						//支付失败
						me._payFail();
					}
				});
		}

		if (typeof WeixinJSBridge != "undefined") {
			onBridgeReady(paymentData);
		} else {
			if (typeof WeixinJSBridge == "undefined") {
				if (document.addEventListener) {
					document.addEventListener('WeixinJSBridgeReady', onBridgeReady, false);
				} else if (document.attachEvent) {
					document.attachEvent('WeixinJSBridgeReady', onBridgeReady);
					document.attachEvent('onWeixinJSBridgeReady', onBridgeReady);
				}
			}
		}

		uni.requestPayment({
			provider: 'wxpay',
			timeStamp: paymentData.timeStamp,
			nonceStr: paymentData.nonceStr,
			package: paymentData.package,
			signType: 'MD5',
			paySign: paymentData.paySign,
			success: (res) => {
				uni.showToast({
					title: '支付成功！',
					duration: 1000,
					icon: 'none'
				})
				setTimeout(function() {
					me.$store.state.payRes = me.order_list
					uni.redirectTo({
						url: "payResult"
					})
					me.pay_display = false
				}, 1000)
			},
			fail: (res) => {
				me._payFail();
			},
			complete: () => {
				me.loading = false;
				uni.hideLoading();
			}
		})
	}
	// #endif

	// #ifndef H5
	uni.requestPayment({
		provider: providerStr,
		orderInfo: orderInfo.data, //订单数据
		success: function(res) {
			uni.showToast({
				title: '支付成功！',
				duration: 1000,
				icon: 'none'
			})
			setTimeout(function() {
				me.$store.state.payRes = me.order_list
				uni.redirectTo({
					url: "payResult"
				})
				me.pay_display = true
			}, 1000)
		},
		fail: function(err) {
			var str = JSON.stringify(err)
			me._payFail();
		}
	});
	// #endif
}

/**
 * 余额支付
 * @param {Object} fromPage
 * @param {Object} type
 */
export function laikePayAxios(fromPage, type) {
	var me = fromPage;
	if (!me.fastTap) {
		return
	}
	me.fastTap = false
	var data = {
		module: 'app',
		action: 'pay',
		app: 'wallet_pay',
		m: 'wallet_pay',
		type: 'wallet_pay',
		access_id: me.access_id,
		address_id: me.address_id ? me.address_id : me.addre_id,
		order_list: me.order_list,
	}
	if (me.bargain) {
		data.order_no = me.order_no
		data.type_ = 'KJ'
	}
	if (me.pay_name == "jp") {
		data.payment_money = me.jp_zong
	} else {
		data.payment_money = me.value
	}
	uni.request({
		data,
		url: uni.getStorageSync("url"),
		header: {
			'content-type': 'application/x-www-form-urlencoded'
		},
		method: 'POST',
		success: (res) => {
			me.fastTap = true
			let {
				data: {
					code,
					message
				}
			} = res
			if (code == 200) {
				if (Number(me.price1) > 0) {
					// #ifdef MP-WEIXIN
					me.weixinPay()
					// #endif
					//#ifndef MP-WEIXIN
					if (me.wxPayStatue) {
						me.pay_wx('wx')
					} else if (me.aliPayStatue) {
						me.pay_wx('ali')
					}
					// #endif
				} else {
					uni.hideLoading();
					var dat_id = me.order_id ? me.order_id : me.or_id
					uni.showToast({
						title: '支付成功！',
						duration: 1000,
						icon: 'none'
					})
					setTimeout(function() {
						if (me.pay_name == "jp") {
							uni.redirectTo({
								url: "payResult?payment_money=" + me.jp_zong + "&sNo=" + me.sNo + "&order_id=" + dat_id
							})
						} else {
							me.$store.state.payRes = me.order_list
							uni.redirectTo({
								url: "payResult"
							})
						}

						me.pay_display = false
					}, 1000)
				}
			} else if (code == 112) {
				uni.hideLoading();
				me.pay_display = false
				me.msg = ""
				me.firstFlag = true
				uni.showModal({
					title: '提示',
					content: '支付失败,订单已生成，可以在订单列表中查看',
					showCancel: false,
					success: function(res) {
						if (res.confirm) {
							uni.redirectTo({
								url: '../order/myOrder'
							})
						}
					}
				})
			} else {
				uni.hideLoading();
				me.pay_display = false
				me.msg = ""
				uni.showModal({
					title: '提示',
					content: '网络繁忙，支付失败  订单已生成，可以在订单列表中查看',
					showCancel: false,
					success: function(res) {
						me.firstFlag = true
						if (res.confirm) {
							uni.switchTab({
								url: '../tabBar/home'
							})
						}
					}
				})
			}
		},
		error: function(err) {
			me.fastTap = true
		}
	})
}

/**
 * 支付取消
 * @param {Object} fromPage
 */
export function laikePayAxiosCancle(fromPage) {
	var me = fromPage;
	me.pay_display = false
	me.msg = ""
	me.firstFlag = true
	uni.showModal({
		title: '提示',
		content: '支付失败,查看订单详情',
		success: function(res) {
			if (res.confirm) {
				uni.redirectTo({
					url: '../order/myOrder'
				})
			} else if (res.cancel) {
				uni.switchTab({
					url: '../tabBar/home'
				})
			}
		}
	});
}

/**
 * 余额支付成功
 * 
 * @param {Object} fromPage
 */
export function laikePayAxiosOk(fromPage, payNum) {
	var me = fromPage;
	if (!me.fastTap) {
		console.log('exit');
		return
	}

	me.fastTap = false
	if (me.enterless) {
		uni.showLoading({
			title: '支付中...',
			mask: true,
		})
		if (me.msg.length == 6) {
			var data = {
				module: 'app',
				action: 'user',
				app: 'payment_password',
				access_id: me.access_id,
				password: me.msg,
				endTime: '',
			}
			uni.request({
				data,
				url: uni.getStorageSync("url"),
				header: {
					'content-type': 'application/x-www-form-urlencoded'
				},
				method: 'POST',
				success: (res) => {
					let {
						data: {
							code,
							message,
							enterless
						}
					} = res
					if (code == 200) {
						me.pay_display = false
						me.fastTap = true
						me._payAxios()

					} else if (enterless) {
						uni.hideLoading();
						me.msg = '';
						uni.showToast({
							title: '您输入密码错误,请重新输入',
							duration: 1000,
							icon: 'none'
						})
						me.enterless = enterless
						me.fastTap = true
					} else if (!enterless) {
						uni.hideLoading();
						uni.showToast({
							title: '你输入的错误次数已达当日上限，请使用其它支付方式进行付款',
							duration: 1000,
							icon: 'none'
						})
						me.pay_display = false;
						me.enterless = false;
						me.fastTap = true
					}
				},
				error: function(err) {
					uni.hideLoading();
					uni.showToast({
						title: '网络错误，请稍后再试',
						duration: 1000,
						icon: 'none'
					})
					me.pay_display = false;
					me.fastTap = true
				}
			})
		} else {
			uni.hideLoading();
			me.fastTap = true
			uni.showToast({
				title: '请输入完整密码！',
				duration: 1000,
				icon: 'none'
			})
		}
	} else {
		me.fastTap = true
		uni.showToast({
			title: '你输入的错误次数已达当日上限，请使用其它支付方式进行付款',
			duration: 1000,
			icon: 'none'
		})
		me.pay_display = false;
	}
}


/**
 * 立即支付
 * @param {Object} fromPage
 */
export function laikePayAtOnce(fromPage) {
	var me = fromPage
	if (me.value == 0 && me.useWallte) {
		me.useWallte = false
	}
	if (me.can_pay) {
		console.log('click')
		me.can_pay = false
		setTimeout(function() {
			me.can_pay = true
		}, 1500)
	} else {
		return false
	}
	me._gotPayType();
	if (me.firstFlag) {
		me.firstFlag = false
		if (!me.value) {
			me.value = 0
		}
		if (me.bargain) {
			me.price1 = me.products_total + me.freight - Number(me.value)
		} else {
			me.price1 = me.products_total + me.freight - me.coupon_name - Number(me.reduce_money) - Number(me.value)
		}
		me.price1 = me.price1.toFixed(2)
		// 提交订单
		if (me.adds_f) {
			if (me.useWallte) { //钱包支付
				console.log('立即支付5');
				if (me.password_status == 0) {
					uni.showModal({
						title: '提示',
						content: '请先设置支付密码',
						showCancel: true,
						success: function(resM) {
							me.firstFlag = true;
							if (resM.confirm) {
								uni.navigateTo({
									url: '../setUp/payment'
								});
							}
						}
					})
				} else {
					let heji = Number(me.products_total) * Number(me.discount) + Number(me.freight) - Number(me.coupon_name) -
						Number(me.reduce_money)
					if (Number(me.needpay) != 0 || Number(heji).toFixed(2) > Number(me.value).toFixed(2)) {
						
						if (me.wxPayStatue || me.aliPayStatue) {
							
						} else {
							uni.showToast({
								title: '金额不足以支付商品价格!',
								icon: 'none',
								duration: 1500
							});
							return false
						}
					}
					if (me.pay_name == "jp") {
						console.log('pay_name');
						var data = {
							module: 'app',
							action: 'order',
							app: 'payment',
							access_id: me.access_id,
							address_id: me.address_id,
							type: "JP",
							auction_id: me.bind_id,
							product: me.cpId,
							coupon_id: me.coupon_id,
							remarks: me.remarks,
						}
					} else if (me.bargain) {
						console.log('bargain');
						var data = {
							module: 'app',
							action: 'order',
							app: 'payment',
							cart_id: me.cart_id,
							access_id: me.access_id,
							address_id: me.address_id,
							product: me.cpId,
							type: "KJ",
							coupon_id: me.coupon_id,
							bargain_id: me.bargain_id,
							bargain_order_no: me.order_no,
							remarks: me.remarks,
						}
					} else {
						console.log('else');
						var data = {
							module: 'app',
							action: 'order',
							app: 'payment',
							cart_id: me.cart_id,
							access_id: me.access_id,
							address_id: me.address_id,
							product: me.cpId,
							coupon_id: me.coupon_id,
							bargain_id: me.bargain_id,
							bargain_order_no: me.order_no,
							remarks: me.remarks,
						}
					}

					if (me.wxPayStatue) {
						// #ifdef MP-WEIXIN
						data.pay_type = 'mini_wechat'
						data.store_type = 1
						// #endif
						//#ifdef APP-PLUS
						data.pay_type = 'app_wechat'
						data.store_type = 2
						// #endif
						//#ifdef H5
						data.pay_type = 'jsapi_wechat'
						data.store_type = 2
						// #endif
					} else if (me.aliPayStatue) {
						data.pay_type = 'aliPay'
					}
					uni.request({ //创建订单
						data,
						url: uni.getStorageSync("url"),
						header: {
							'content-type': 'application/x-www-form-urlencoded'
						},
						method: 'POST',
						success: (res1) => {
							if (res1.data.code == 404) {
								uni.hideLoading();
								return
							}
							let {
								data: {
									status,
									data
								}
							} = res1
							if (status == 1) { //创建成功
								me.makeOrd = true
								me.sNo = res1.data.data.sNo
								me.order_list = JSON.stringify(data)
							} else {
								me.firstFlag = true
								uni.hideLoading();
								uni.showToast({
									title: "创建订单失败,请稍后再试!",
									duration: 1500,
									icon: 'none'
								})
								setTimeout(function() {
									uni.navigateBack({
										url: '../good/goodsDetailed'
									})
								}, 1500)
							}
						},
					})
					if (me.price1 > 0) { //其他方式抵扣
						console.log('立即支付6');
						let heji = Number(me.products_total) * Number(me.discount) + Number(me.freight) - Number(me.coupon_name) -
							Number(me.reduce_money)
							heji = heji.toFixed(2)
						if (Number(me.needpay) != 0 || heji > me.value) {
							if (me.wxPayStatue || me.aliPayStatue) {
								me.pay_display = true
							} else {
								me.firstFlag = true
								uni.showToast({
									title: '金额不足以支付商品价格!!',
									icon: 'none',
									duration: 1500
								});
								return false
							}
							console.log('立即支付7');
							// #ifdef MP-WEIXIN
							console.log('立即支付9');
							me.pay_display = true
							// #endif
						} else {
							console.log('立即支付8');
							me.pay_display = true
						}
					} else { //余额支付
						me.pay_display = true
					}
				}
			} else {
				//支付宝或微信支付--创建订单
				uni.showLoading({
					title: '正在请求支付...',
					mask: true,
				})
				// #ifdef MP-WEIXIN
				if (me.pay_name == "jp") {
					var data = {
						module: 'app',
						action: 'order',
						app: 'payment',
						access_id: me.access_id,
						address_id: me.address_id,
						type: "JP",
						auction_id: me.bind_id,
						coupon_id: me.coupon_id,
						bargain_order_no: me.order_no
					}
					if (me.cpId) {
						data.product = me.cpId
						cart_id: ''
					}
					data.pay_type = 'mini_wechat'
					data.store_type = 1
				} else if (me.bargain) {
					var data = {
						module: 'app',
						action: 'order',
						app: 'payment',
						type: "KJ",
						cart_id: me.cart_id,
						access_id: me.access_id,
						address_id: me.address_id,
						bargain_id: me.bargain_id,
						bargain_order_no: me.order_no
					}
					if (me.cpId) {
						data.product = me.cpId
						cart_id: ''
					}
					data.pay_type = 'mini_wechat'
					data.store_type = 1
				} else {
					var data = {
						module: 'app',
						action: 'order',
						app: 'payment',
						cart_id: me.cart_id,
						access_id: me.access_id,
						address_id: me.address_id,
						coupon_id: me.coupon_id,
						bargain_order_no: me.order_no
					}
					if (me.cpId) {
						data.product = me.cpId
						cart_id: ''
					}
					data.pay_type = 'mini_wechat'
					data.store_type = 1
				}
				console.log('立即支付3');

				uni.request({ //创建订单
					data,
					url: uni.getStorageSync("url"),
					header: {
						'content-type': 'application/x-www-form-urlencoded'
					},
					method: 'POST',
					success: (res1) => { //支付
						let {
							data: {
								status,
								data
							}
						} = res1
						me.order_list = JSON.stringify(data)
						console.log('立即支付2');

						if (status == 1) {
							me.weixinPay()
						} else {
							me.firstFlag = true
							uni.showToast({
								title: "创建订单失败,请稍后再试!",
								duration: 1500,
								icon: 'none'
							})
							setTimeout(function() {
								uni.navigateBack({
									delta: 1
								})
							}, 1500)
						}
					},
					error: function(err) {
						me.firstFlag = true
						uni.showToast({
							title: "创建订单失败,请稍后再试!",
							duration: 1500,
							icon: 'none'
						})
						setTimeout(function() {
							uni.navigateBack({
								delta: 1
							})
						}, 1500)
					}
				})
				// #endif
				// #ifndef MP-WEIXIN
				// me.showPayWay=true//弹窗
				me.payThree();
				// #endif
			}
		} else {
			uni.showToast({
				title: "请完善收货地址！",
				duration: 1000,
				icon: 'none'
			})
		}
	}
}


/**
 * 获取支付类型
 * @param {Object} fromPage
 */
export function laikeGetPayType(fromPage) {
	var me = fromPage;
	if (!me.useWallte && !me.wxPayStatue && !me.aliPayStatue) {
		uni.showToast({
			title: "请选择支付方式！",
			duration: 1000,
			icon: 'none'
		})
		me.firstFlag = false;
	} else {
		me.firstFlag = true;
	}
}


/**
 * 弹出优惠券窗口
 * @param {Object} fromPage
 */
export function laikeShowCoupon(fromPage) {
	var me = fromPage;
	me.use_coupon = true
	var data = {
		module: 'app',
		action: 'Coupon',
		app: 'my_coupon',
		access_id: me.access_id,
		cart_id: me.cart_id,
		product: me.cpId
	}
	uni.request({
		data,
		url: uni.getStorageSync("url"),
		header: {
			'content-type': 'application/x-www-form-urlencoded'
		},
		method: 'POST',
		success: (res) => {
			if (res.data.code == 200) {
				let {
					data: {
						list
					}
				} = res
				me.coupon_list = list
			} else {
				uni.showToast({
					title: res.data.message,
					duration: 1500,
					icon: 'none'
				})
			}
		},
		error: function(err) {
			console.log(err)
		},
	})
}

/**
 *  关闭优惠券弹出层的计算
 */
export function laikeCloseCoupon(fromPage){
	var me = fromPage;
	me.use_coupon = false
	var data = {
		module: 'app',
		action: 'Coupon',
		app: 'getvou',
		access_id: me.access_id,
		cart_id: me.cart_id,
		address_id: me.address_id,
		coupon_id: me.coupon_id,
		product: me.cpId
	}
	
	if (me.coupon_id.length > 0) {
		uni.request({
			data,
			url:  uni.getStorageSync("url"),
			header: {
				'content-type': 'application/x-www-form-urlencoded'
			},
			method: 'POST',
			success: function(res) {
				if (res.data.code == 200) {
					var money = res.data.money
					
					me.freightt = parseFloat(res.data.freight).toFixed(2);
					me.freight = res.data.freight;
					
					me.coupon_name1 = res.data.coupon_name
					let heji = Number(me.products_total)+Number(me.freight)-Number(me.coupon_name)-Number(me.reduce_money)
					me.total = heji;
				} else {
					uni.showToast({
						title: res.data.message,
						duration: 1500,
						icon: 'none'
					})
				}
				if (res.statusCode == 200) {
					me.coupon_name = res.data.money;
					me.total = me.products_total + me.freight - me.coupon_name - me.reduce_money
					console.log(me.products_total);
					console.log(me.freight);
					console.log(me.coupon_name);
					console.log(me.reduce_money);
					if(me.useWallte){
						if (me.total >= Number(me.user_money)) {
							me.value = me.user_money
							console.log("me.value=================10");
							console.log(me.value);
							me.needpay = parseFloat(me.products_total - Number(me.user_money)).toFixed(2)
						} else {
							me.value = me.total
							console.log("me.value=================11");
							console.log(me.value);
							me.needpay = 0
						}
					}else{
						if(me.total > 0){
							me.needpay = parseFloat(me.total).toFixed(2)
						}else{
							me.needpay = 0.01
						}
					}
				}
			}
		})
	}
}


/**
 * 选择优惠券
 * 
 * @param {Object} fromPage
 * @param {Object} index
 * @param {Object} id
 * @param {Object} coupon_status
 */
export function laikeChooseCoupon(fromPage,index, id, coupon_status){
	var me = fromPage ;
	if (coupon_status == 1) {
		var length = me.coupon_list.length
		if (me.coupon_id.length > 0) {
			if (id == 0) {
				me.coupon_id = [0]
			} else {
				me.coupon_id = id
			}
		} else {
			me.coupon_id = id
		}
	} else {
		uni.showToast({
			title: '不能使用该优惠券',
			icon: 'none',
			duration: 1500
		})
	}
}


